<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Jrg Delker (joerg@delker.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Fetch URL' for the 'fetchurl' extension.
 *
 * @author	Jrg Delker <joerg@delker.de>
 */


require_once(PATH_tslib."class.tslib_pibase.php");

class tx_fetchurl_pi1 extends tslib_pibase {
	var $prefixId = "tx_fetchurl_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_fetchurl_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "fetchurl";	// The extension key.
	
	/**
	 * [Put your description here]
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		
		// determine base URL
		if (preg_match("/(https*:\/\/.*?)(\/|$)/", $this->cObj->data['tx_fetchurl_url'],$matches)) {
			$baseurl=$matches[1];
		}

		// determine relative URL
		if (preg_match("/(https*:\/\/.*\/)[^\/]*/", $this->cObj->data['tx_fetchurl_url'],$matches)) {
			$relurl=$matches[1];
		}

		// fetch URL
		$content= t3lib_div::getURL($this->cObj->data['tx_fetchurl_url']);

		// cut out body (if present)
		if (preg_match("/<body .*?>(.*)<\/body/si",$content,$matches)) {
			$content=$matches[1];
		}

		// substitute links & image URIs
		$patterns = array( "/src=\"(\w[^:]+?)\"/i", 
				   "/src=\"\/([^:]+?)\"/i",
				   "/href=\"(\w[^:]+?)\"/i",
				   "/href=\"\/([^:]+?)\"/i"
			    );
		$replacements = array( "src=\"".$relurl."/$1\"",
				       "src=\"".$baseurl."/$1\"",
				       "href=\"".$relurl."/$1\"",
				       "href=\"".$baseurl."/$1\""
				);
		$content=preg_replace($patterns,$replacements,$content);

		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/fetchurl/pi1/class.tx_fetchurl_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/fetchurl/pi1/class.tx_fetchurl_pi1.php"]);
}

?>
